<?php

namespace app\api\logic;

use app\common\enum\GoodsEnum;
use app\common\enum\PayEnum;
use app\common\enum\WorkEnum;
use app\common\logic\BaseLogic;
use app\common\logic\PaymentLogic;
use app\common\model\coupon\UserCoupon;
use app\common\model\dict\DictData;
use app\common\model\goods\Goods;
use app\common\model\master_worker\MasterWorker;
use app\common\model\orders\RechargeOrder;
use app\common\model\recharge\OrderGoods;
use app\common\model\refund\RefundRecord;
use app\common\model\spare_part\SparePart;
use app\common\model\works\ServiceWork;
use app\common\model\works\ServiceWorkSpare;
use app\workerapi\logic\ServiceWorkLogLogic;
use think\Exception;
use think\facade\Db;


/**
 *  订单逻辑层
 * Class ServiceOrderLogic
 * @package app\api\logic
 */
class ServiceOrderLogic extends BaseLogic
{
    /**
     * 提交订单
     * @param array $params
     * @return array|false
     */
    public static function submitOrder($params)
    {
        Db::startTrans();
        try {
            $goods = Goods::findOrEmpty($params['goods_id']);
            if($goods->isEmpty()){
                throw new Exception('产品不存在！');
            }
            if(empty($params['user_info']['mobile'])){
                throw new Exception('请先补充您的联系方式后在提交订单');
            }

            //根据服务工单计算当前订单应支付金额
            if($goods['goods_payment_type'] == GoodsEnum::ISGOODS_PAYMENT_TYPE){
                //一口价订单
                $order_total = $goods['service_fee'];
                $order_amount = $goods['service_fee'];
            }else{
                $order_total = $goods['base_service_fee'];
                $order_amount = $goods['service_fee'];
            }

            //优惠券验证
            if(!empty($params['coupon_id'])){
                $user_coupon = UserCoupon::where(['id'=>$params['coupon_id'],'user_id'=>$params['user_id'],'voucher_status'=>0])
                    ->where('voucher_count','>',0)
                    ->where('expire_time','>=',time())
                    ->where('begin_use','<',time())
                    ->findOrEmpty();
                if($user_coupon->isEmpty()){
                   throw new Exception('该优惠券无法使用');
                }
                if($goods['goods_payment_type'] == GoodsEnum::ISGOODS_PAYMENT_TYPE and $order_amount<$user_coupon['amount_require']){
                    throw new Exception('该优惠劵不满足满减使用条件');
                }
                if($goods['goods_payment_type'] != GoodsEnum::ISGOODS_PAYMENT_TYPE){
                    throw new Exception('请在支付尾款的时候使用该优惠券');
                }
                //优惠券折扣
                if($user_coupon['mold_type'] == 1){
                    //按比例折扣
                    if($user_coupon['discount_ratio']>=1){
                        throw new Exception('优惠券有误，请联系客服');
                    }
                    $order_coupon_amount = intval($order_amount*(1-$user_coupon['discount_ratio']));
                }else{
                    $order_coupon_amount = $user_coupon['amount'];
                }
                if(!empty($user_coupon['max_deductible_price'])){
                    $order_amount = ($order_coupon_amount>$user_coupon['max_deductible_price'])?($order_amount-$user_coupon['max_deductible_price']):($order_amount-$order_coupon_amount);
                }else{
                    $order_amount = $order_amount-$order_coupon_amount;
                }
                $user_coupon->voucher_status = 1;
                $user_coupon->voucher_count = $user_coupon->voucher_count-1;
                $user_coupon->save();
            }

            //生成服务工单
            $work_data = [
                'work_sn' => generate_sn(ServiceWork::class, 'work_sn'),
                'real_name' => $params['contact_people'],
                'mobile' => $params['contact_number'],
                'address' => $params['address'],
                'title' => $goods->goods_name . '*' . $goods->goods_number.$goods->good_unit,
                'category_type' => $goods['category_type'],
                'goods_category_ids' => $goods['goods_category_ids'],
                'goods_category_id' => $goods['goods_category_id'],
                'base_service_fee' => $goods['base_service_fee'],
                'service_fee' => $goods['service_fee'],
                'work_pay_status'=>WorkEnum::UN_PAY_STATUS,
                'appointment_time' => strtotime($params['appointment_time']),
                'user_id'=>$params['user_id'],
                'lon'=>!empty($params['lon'])?$params['lon']:0,
                'lat'=>!empty($params['lat'])?$params['lat']:0,
            ];

            //判断是否是加单
            if(!empty($params['worker'])){
                $worker_id = MasterWorker::where('worker_number',$params['worker'])->value('id');
                $work_data['master_worker_id'] = $worker_id;
                $work_data['work_status'] = 1;
                $work_data['dispatch_time'] = time();
                $work_data['work_type'] = 2;
            }

            $service_work = ServiceWork::create($work_data);

            //生成服务订单
            $data = [
                'work_id'=> $service_work['id'],
                'sn' => generate_sn(RechargeOrder::class, 'sn'),
                'order_type'=>0,//服务订单
                'order_terminal' => $params['terminal'],
                'payment_type'=>$goods['goods_payment_type']==1?1:0,
                'user_id' => $params['user_id'],
                'pay_status' => PayEnum::UNPAID,
                'coupon_id'=>!empty($params['coupon_id'])?$params['coupon_id']:0,
                'coupon_price'=>!empty($order_coupon_amount)?$order_coupon_amount:0,
                'pay_way' => $params['pay_way'],
                'order_total' => $order_total,
                'order_amount' => $order_amount,
            ];

            $order = RechargeOrder::create($data);
            //生成订单服务详情
            OrderGoods::create([
                'sn' => $order['sn'],
                'goods_id' => $params['goods_id'],
                'category_type' => $goods['category_type'],
                'goods_category_ids' => $goods['goods_category_ids'],
                'goods_category_id' => $goods['goods_category_id'],
                'goods_name' => $goods['goods_name'],
                'goods_image' => $goods['goods_image'],
                'goods_video' => $goods['goods_video'],
                'goods_number' => $goods['goods_number'],
                'good_unit' => $goods['good_unit'],
                'goods_size' => $goods['goods_size'],
                'goods_type' => $goods['goods_type'],
                'goods_brand' => $goods['goods_brand'],
                'install_guide' => $goods['install_guide'],
                'goods_payment_type'=>$goods['goods_payment_type'],
                'base_service_fee' => $goods['base_service_fee'],
                'service_total' => $goods['service_total'],
                'service_fee' => $goods['service_fee'],
                'service_image' => $goods['service_image'],
                'warranty_period'=>$goods['warranty_period'],
                'fee_schedule' => $goods['fee_schedule'],
                'goods_status' => $goods['goods_status'],
            ]);
            Db::commit();
        } catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }

        return [
            'order_id' => (int)$order['id'],
            'work_id' => (int)$order['work_id'],
        ];
    }

    /**
     * 提交尾款订单
     * @param array $params
     * @return array|false
     */
    public static function submitFinalOrder($params)
    {
        Db::startTrans();
        try {
            $order = \app\common\model\recharge\RechargeOrder::where('sn',$params['sn'])->findOrEmpty();
            if ($order->isEmpty()) {
                throw new Exception('订单不存在');
            }
            //判断订单类型.服务订单尾款处理
            if($order['order_type'] == 0 and $order['pay_status'] == PayEnum::ISPAID)//服务工单
            {
                $order = RechargeOrder::where(['work_id'=>$order['work_id'],'pay_status'=>0])->findOrEmpty();
                if($order->isEmpty()){
                    throw new Exception('订单已支付');
                }
            }

            if ($order['pay_status'] == PayEnum::ISPAID) {
                throw new Exception('订单已支付');
            }

            $order_goods = OrderGoods::where('sn',$params['sn'])->findOrEmpty();
            $goods = Goods::findOrEmpty($order_goods['goods_id']);
            //判断是否存在优惠券
            //优惠券验证
            if(!empty($order['coupon_id'])){
                $order->coupon_id = 0;
                $order->coupon_price = 0;
                $order->order_amount = $order->order_total;
                $order->save();
                $user_coupon_ed = UserCoupon::findOrEmpty($order['coupon_id']);
                $user_coupon_ed->voucher_count = $user_coupon_ed->voucher_count+1;
                $user_coupon_ed->voucher_status = 0;
                $user_coupon_ed->save();
                $order = \app\common\model\recharge\RechargeOrder::where('sn',$order['sn'])->findOrEmpty();
            }
            if(!empty($params['coupon_id']) && empty($order['coupon_id'])){
                $user_coupon = UserCoupon::where(['id'=>$params['coupon_id'],'user_id'=>$params['user_id'],'voucher_status'=>0])
                    ->where('voucher_count','>',0)
                    ->where('expire_time','>=',time())
                    ->where('begin_use','<',time())
                    ->findOrEmpty();
                if($user_coupon->isEmpty()){
                    throw new Exception('该优惠券无法使用');
                }
                if($goods['goods_payment_type'] == GoodsEnum::ISGOODS_PAYMENT_TYPE and $order['order_amount']<$user_coupon['amount_require']){
                    throw new Exception('该优惠劵不满足满减使用条件');
                }
                //优惠券折扣
                if($user_coupon['mold_type'] == 1){
                    //按比例折扣
                    if($user_coupon['discount_ratio']>=1){
                        throw new Exception('优惠券有误，请联系客服');
                    }
                    $order_coupon_amount = intval($order['order_amount']*(1-$user_coupon['discount_ratio']));
                }else{
                    $order_coupon_amount = $user_coupon['amount'];
                }
                if(!empty($user_coupon['max_deductible_price'])){
                    $order_amount = ($order_coupon_amount>$user_coupon['max_deductible_price'])?($order['order_amount']-$user_coupon['max_deductible_price']):($order['order_amount']-$order_coupon_amount);
                }else{
                    $order_amount = $order['order_amount']-$order_coupon_amount;
                }
                $user_coupon->voucher_status = 1;
                $user_coupon->voucher_count = $user_coupon->voucher_count-1;
                $user_coupon->save();
            }

            $order->coupon_id = !empty($params['coupon_id'])?$params['coupon_id']:0;
            $order->coupon_price = !empty($order_coupon_amount)?$order_coupon_amount:0;
            $order->order_amount = !empty($order_amount)?$order_amount:$order->order_amount;
            $order->save();
            Db::commit();
        } catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }

        return [
            'order_id' => (int)$order['id'],
            'work_id' => (int)$order['work_id'],
        ];
    }

    /**
     * 重置订单优惠券
     * * @param $params
     * * * @return array|false
 */
    public static function cancelOrderCoupon($params)
    {
        Db::startTrans();
        try {
            $order = \app\common\model\recharge\RechargeOrder::where('sn',$params['sn'])->findOrEmpty();
            if ($order->isEmpty()) {
                throw new Exception('订单不存在');
            }
            //判断订单类型.服务订单尾款处理
            if($order['order_type'] == 0 and $order['pay_status'] == PayEnum::ISPAID)//服务工单
            {
                $order = RechargeOrder::where(['work_id'=>$order['work_id'],'pay_status'=>0])->findOrEmpty();
                if($order->isEmpty()){
                    throw new Exception('订单已支付');
                }
            }

            if ($order['pay_status'] == PayEnum::ISPAID) {
                throw new Exception('订单已支付');
            }

            if(!empty($order['coupon_id'])){
                $user_coupon_ed = UserCoupon::findOrEmpty($order['coupon_id']);
                if(!$user_coupon_ed->isEmpty()){
                    $user_coupon_ed->voucher_count = $user_coupon_ed->voucher_count+1;
                    $user_coupon_ed->voucher_status = 0;
                    $user_coupon_ed->save();

                    $order->order_amount = $order->order_amount+$order->coupon_price;
                    $order->coupon_id = 0;
                    $order->coupon_price = 0;
                    $order->save();
                }
            }
            Db::commit();
        } catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }

    }

    /**
     * 获取订单工程师信息
     * * @param $params
     * * @return array|false
 */
    public static function getMasterWorker($params)
    {
        try {
            $order_info =  \app\common\model\recharge\RechargeOrder::with(['order_goods'=>function ($query) {
                $query->visible(['goods_name','goods_image','goods_number','good_unit']);
            },'service_work'=>function ($query) {
                $query->visible(['real_name','mobile','address','service_status','appointment_time','master_worker_id','work_images','finished_images','finished_time'])->append(['service_status_text','user_service_status','user_service_status_text']);
            }])
                ->visible(['id','sn','payment_type','order_total','order_amount','pay_status','create_time','title','work_id'])
                ->where([
                    'order_type' => 0,
                    'user_id' => $params['user_id'],
                    'sn'=>$params['sn']
                ])->findOrEmpty()->toArray();

            $data = [];
            //获取师傅参数
            if(!empty($order_info['service_work']['master_worker_id'])){
                $worker = MasterWorker::find($order_info['service_work']['master_worker_id']);
                $data['avatar'] = $worker['avatar'];
                $data['real_name'] = $worker['real_name'];
                $data['worker_number'] = $worker['worker_number'];
                $data['mobile'] = $worker['mobile'];
                $maintain_exp_type = !empty($worker->worker_register->maintain_exp_type)?$worker->worker_register->maintain_exp_type:'';
                $data['worker_exp'] = DictData::where(['type_value'=>'worker_exp_type','value'=>$maintain_exp_type])->value('name');
                $data['appointment_time'] = $order_info['service_work']['appointment_time'];
            }

            return  $data;

        }
        catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }
    }

    /**
     * 获取订单详情
     * @param $params
     * @return array|false
     */
    public static function detail($params)
    {
        try {
            $order_info =  \app\common\model\recharge\RechargeOrder::with(['order_goods'=>function ($query) {
                $query->visible(['goods_name','goods_image','goods_number','good_unit']);
            },'service_work'=>function ($query) {
                $query->visible(['real_name','mobile','address','service_status','appointment_time','master_worker_id','work_images','finished_images','finished_time','spare_total','service_work_spare_id'])->append(['service_status_text','user_service_status','user_service_status_text']);
            }])
                ->visible(['id','sn','payment_type','order_total','order_amount','paid_amount','pay_status','create_time','title','work_id'])
                ->where([
                    'order_type' => 0,
                    'user_id' => $params['user_id'],
                    'sn'=>$params['sn']
                ])->findOrEmpty()->toArray();

            if(empty($order_info)){
                throw new Exception('订单不存在');
            }

            $order_info['master_worker'] = [
                'avatar' => '',
                'real_name'=>'',
                'worker_number'=>'',
                'mobile'=>'',
                'worker_exp'=>''
            ];



            //查询总价
            $order_info['order_amount'] = \app\common\model\recharge\RechargeOrder::where(['order_type'=>0,'user_id'=>$params['user_id'],'work_id'=>$order_info['work_id']])->sum('order_amount');
            $order_info['paid_amount'] = \app\common\model\recharge\RechargeOrder::where(['order_type'=>0,'user_id'=>$params['user_id'],'work_id'=>$order_info['work_id']])->sum('paid_amount');

            //退款金额
            $order_refund_amount = 0;

            //获取师傅参数
            if(!empty($order_info['service_work']['master_worker_id'])){
                $worker = MasterWorker::find($order_info['service_work']['master_worker_id']);
                $order_info['master_worker']['avatar'] = $worker['avatar'];
                $order_info['master_worker']['real_name'] = $worker['real_name'];
                $order_info['master_worker']['worker_number'] = $worker['worker_number'];
                $order_info['master_worker']['mobile'] = $worker['mobile'];
                $maintain_exp_type = !empty($worker->worker_register->maintain_exp_type)?$worker->worker_register->maintain_exp_type:'';
                $order_info['master_worker']['worker_exp'] = DictData::where(['type_value'=>'worker_exp_type','value'=>$maintain_exp_type])->value('name');
            }
            //搜索当前工单下的所有订单记录
            $order_info['pay_orders'] = \app\common\model\recharge\RechargeOrder::where(['work_id'=>$order_info['work_id']])->field('id as order_id, pay_status ,refund_status,payment_type,pay_way,pay_time,order_total,order_amount,coupon_price')->order('id asc')->select()->toArray();

            $pay_status_data = DictData::where('type_value','pay_status')->column('name','value');
            $payment_type_data = DictData::where('type_value','payment_type')->column('name','value');
            $pay_way_data = DictData::where('type_value','pay_way')->column('name','value');
            $coupon_price = 0;
            foreach ($order_info['pay_orders'] as $k=>&$v){
                $v['pay_status_name'] = $pay_status_data[$v['pay_status']];
                $v['payment_type_name'] = $payment_type_data[$v['payment_type']];
                $v['pay_way_name'] = $pay_way_data[$v['pay_way']];

                if($v['refund_status']==1){
                    $order_refund_amount += $v['order_amount'];
                    $refund_status = RefundRecord::where('order_id',$v['order_id'])->value('refund_status');
                }

                if($v['payment_type']!=1 and !empty($order_info['service_work']['spare_total'])){
                    $v['order_amount_total'] = $v['order_amount'];
                    $v['order_amount'] = $v['order_amount'] - $order_info['service_work']['spare_total'];
                }

                $coupon_price += $v['coupon_price'];
            }

            //汇总优惠卷额度
            $order_info['coupon_price'] = $coupon_price;

            //退款汇总
            $order_info['refund_amount'] = $order_refund_amount;

            if(isset($refund_status)){
                switch ($refund_status){
                    case 0:
                        $order_info['refund_status'] = '退款中';
                        break;
                    case 1:
                        $order_info['refund_status'] = '退款成功';
                        break;
                    case 2:
                        $order_info['refund_status'] = '退款失败';
                        break;
                }
            }else{
                $order_info['refund_status'] = '未退款';
            }

            // 所有配件
            $order_info['spare_total'] = $order_info['service_work']['spare_total']??0;
            $order_info['spare_parts'] = [];
            if($order_info['service_work']['service_work_spare_id']){
                $work_spare_parts = json_decode(ServiceWorkSpare::where('id',$order_info['service_work']['service_work_spare_id'])->value('spare_parts'),true);
                $spare_parts = SparePart::where('id','in',array_column($work_spare_parts,'id'))
                    ->field(['id', 'goods_category_id', 'spare_name', 'spare_image', 'spare_number', 'spare_unit','spare_status'])
                    ->select()
                    ->toArray();
                $spare_parts = array_column($spare_parts,null,'id');
                foreach (array_column($work_spare_parts,null,'id') as $k=>&$v){
                    $spare_parts[$k] = array_merge($spare_parts[$k],$v);
                }
                $order_info['spare_parts'] = array_values($spare_parts)??[];
            }

            return $order_info;
        }
        catch (\Exception $e) {
                self::setError($e->getMessage());
                return false;
            }
    }


    /**
     * 获取订单支付详情
     * @param $params
     * @return array|false
     */
    public static function orderPayInfo($params)
    {
        try {
            $order_info =  \app\common\model\recharge\RechargeOrder::with(['order_goods'=>function ($query) {
                $query->visible(['goods_payment_type','goods_category_id']);
            },'service_work'=>function ($query) {
                $query->visible(['service_fee','spare_total','service_work_spare_id']);
            }])
                ->visible(['id','sn','work_id'])
                ->where([
                    'order_type' => 0,
                    'user_id' => $params['user_id'],
                    'sn'=>$params['sn']
                ])->findOrEmpty()->toArray();

            if(empty($order_info)){
                throw new Exception('订单不存在');
            }

            //查询总价
            $order_info['order_amount'] = \app\common\model\recharge\RechargeOrder::where(['order_type'=>0,'user_id'=>$params['user_id'],'work_id'=>$order_info['work_id']])->sum('order_amount');
            $order_info['paid_amount'] = \app\common\model\recharge\RechargeOrder::where(['order_type'=>0,'user_id'=>$params['user_id'],'work_id'=>$order_info['work_id']])->sum('paid_amount');

            //搜索当前工单下的所有订单记录
            $order_info['pay_orders'] = \app\common\model\recharge\RechargeOrder::where(['work_id'=>$order_info['work_id']])->field('id as order_id, pay_status,refund_status,payment_type,pay_way,pay_time,order_total,order_amount,coupon_price')->order('id asc')->select()->toArray();

            $pay_status_data = DictData::where('type_value','pay_status')->column('name','value');
            $payment_type_data = DictData::where('type_value','payment_type')->column('name','value');
            $pay_way_data = DictData::where('type_value','pay_way')->column('name','value');
            $coupon_price = 0;
            //退款金额
            $order_refund_amount = 0;
            foreach ($order_info['pay_orders'] as $k=>&$v){
                $v['pay_status_name'] = $pay_status_data[$v['pay_status']];
                $v['payment_type_name'] = $payment_type_data[$v['payment_type']];
                $v['pay_way_name'] = $pay_way_data[$v['pay_way']];
                if($v['refund_status']==1){
                    $order_refund_amount += $v['order_amount'];
                    $refund_status = RefundRecord::where('order_id',$v['order_id'])->value('refund_status');
                }
                if($v['payment_type']!=1 and !empty($order_info['service_work']['spare_total'])){
                    $v['order_total'] = $v['order_total'] - $order_info['service_work']['spare_total'];
                    $v['order_amount'] = $v['order_amount'] - $order_info['service_work']['spare_total'] + $v['coupon_price'];
                }

                $coupon_price += $v['coupon_price'];
            }

            //汇总优惠卷额度
            $order_info['coupon_price'] = $coupon_price;
            //退款汇总
            $order_info['refund_amount'] = $order_refund_amount;
            if(isset($refund_status)){
                switch ($refund_status){
                    case 0:
                        $order_info['refund_status'] = '退款中';
                        break;
                    case 1:
                        $order_info['refund_status'] = '退款成功';
                        break;
                    case 2:
                        $order_info['refund_status'] = '退款失败';
                        break;
                }
            }else{
                $order_info['refund_status'] = '未退款';
            }
            // 所有配件
            $order_info['spare_total'] = $order_info['service_work']['spare_total']??0;
            $order_info['spare_parts'] = [];
            if($order_info['service_work']['service_work_spare_id']){
                $work_spare_parts = json_decode(ServiceWorkSpare::where('id',$order_info['service_work']['service_work_spare_id'])->value('spare_parts'),true);
                $spare_parts = SparePart::where('id','in',array_column($work_spare_parts,'id'))
                    ->field(['id', 'goods_category_id', 'spare_name', 'spare_image', 'spare_number', 'spare_unit','spare_status'])
                    ->select()
                    ->toArray();
                $spare_parts = array_column($spare_parts,null,'id');
                foreach (array_column($work_spare_parts,null,'id') as $k=>&$v){
                    $spare_parts[$k] = array_merge($spare_parts[$k],$v);
                }
                $order_info['spare_parts'] = array_values($spare_parts)??[];
            }

            return $order_info;
        }
        catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * 取消订单
     * @param $params
     * @return false|void
     */
    public static function cancelOrder($params)
    {
        Db::startTrans();
        try {
            $work_id =  \app\common\model\recharge\RechargeOrder::where([
                    'order_type' => 0,
                    'user_id' => $params['user_id'],
                    'sn'=>$params['sn']
                ])->value('work_id');
            if(empty($work_id)){
                throw new Exception('订单不存在');
            }

            $payed_order = \app\common\model\recharge\RechargeOrder::where(['user_id'=>$params['user_id'],'work_id'=>$work_id,'pay_status'=>1])->findOrEmpty();
            if(!$payed_order->isEmpty()){
                throw new Exception('存在已支付订单，不允许取消订单，请联系客服');
            }
            //软删除订单
            $cancel_order = \app\common\model\recharge\RechargeOrder::where(['user_id'=>$params['user_id'],'work_id'=>$work_id])->findOrEmpty();
            $cancel_order->pay_status = 2;
            $cancel_order->save();
            //更新工单状态为已取消
            $service_work = ServiceWork::find($work_id);
            $service_work->service_status = 4;
            $service_work->save();
            //判断如果存在优惠券，返还优惠券
            if(!empty($payed_order->coupon_id)){
                $user_coupon = UserCoupon::where(['user_id'=>$payed_order->user_id,'id'=>$payed_order->coupon_id])->findOrEmpty();
                $user_coupon->voucher_status = 0;
                $user_coupon->voucher_count = $user_coupon->voucher_count+1;
                $user_coupon->save();
            }

            Db::commit();
        }
        catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }
    }

    /**
     * 用户确认尾款报价单
     * @param $params
     * @return false|void
     */
    public static function confirmOrder($params)
    {
        Db::startTrans();
        try {
            $work_id =  \app\common\model\recharge\RechargeOrder::where([
                'order_type' => 0,
                'user_id' => $params['user_id'],
                'sn'=>$params['sn']
            ])->value('work_id');
            if(empty($work_id)){
                throw new Exception('订单不存在');
            }

            //更新工单状态为已取消
            $service_work = ServiceWork::find($work_id);
            if($service_work->user_confirm_status==2){
                throw new Exception('请勿重复操作');
            }
            $service_work->work_status = 5;
            $service_work->user_confirm_status = 2;
            $service_work->save();

            $work_log = [
                'work_id'=>$work_id,
                'master_worker_id'=>$service_work->master_worker_id,
                'opera_log'=>'用户'.$params['user_info']['real_name'].'于'.date('y-m-d H:i:s',time()).'于'.date('Y-m-d H:i:s',time()).'确认了报价单',
            ];
            ServiceWorkLogLogic::add($work_log);
            Db::commit();
        }
        catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }
    }

    /**
     * 用户确认服务完成
     * @param $params
     * @return false|void
     */
    public static function confirmServiceFinish($params)
    {
        Db::startTrans();
        try {
            $work_id =  \app\common\model\recharge\RechargeOrder::where([
                'order_type' => 0,
                'user_id' => $params['user_id'],
                'sn'=>$params['sn']
            ])->value('work_id');
            if(empty($work_id)){
                throw new Exception('订单不存在');
            }

            $service_work = ServiceWork::find($work_id);
            if($service_work->user_confirm_status!=3){
                throw new Exception('请勿重复操作');
            }

            $orders = RechargeOrder::where(['work_id'=>$work_id,'user_id'=>$params['user_id']])->select()->toArray();

            //确认所有订单总金额和结算金额
            //若订单是全款已支付订单
            if(count($orders)==1 and $orders[0]['payment_type']==0 and $orders[0]['pay_status']==1){
                $service_work->work_status = 7;
                $service_work->user_confirm_status = 5;
                $service_work->service_status = 3;
                $service_work->work_pay_status = 1;
            }else{
                $service_work->work_status = 6;
                $service_work->user_confirm_status = 4;
            }
            $service_work->finished_time = time();

            $service_work->save();
            //更新师傅的进行工单数量
            MasterWorker::setWorktotal('dec',$service_work->master_worker_id);
            $work_log = [
                'work_id'=>$work_id,
                'master_worker_id'=>$service_work->master_worker_id,
                'opera_log'=>'用户'.$params['user_info']['real_name'].'于'.date('y-m-d H:i:s',time()).'于'.date('Y-m-d H:i:s',time()).'确认服务完成',
            ];
            ServiceWorkLogLogic::add($work_log);
            Db::commit();
        }
        catch (\Exception $e) {
            self::setError($e->getMessage());
            return false;
        }
    }

    public static function firmOrderSave($params)
    {
        Db::startTrans();
        try {
            $goodIds = array_column($params['order_goods'],'id');
            $goodInfo = Goods::whereIn('id',$goodIds)->select();
            $ids = $goodInfo->column('id');
            if(!empty(array_diff($goodIds,$ids))){
                throw new Exception('产品不存在！');
            }
            if(empty($params['user_info']['mobile'])){
                throw new Exception('请先补充您的联系方式后在提交订单');
            }
            $order_amount = 0;
            $order_total = 0;

            $orderGoodsData = [];
            $goodsPaymentTypeArr = [];
            //计算订单总金额和结算金额
            foreach($params['order_goods'] as $val){
                $goods = $goodInfo->where('id',$val['id'])->toArray()[0];
                //根据服务工单计算当前订单应支付金额
                $order_total = $goods['service_total'];
                if($goods['goods_payment_type'] == GoodsEnum::ISGOODS_PAYMENT_TYPE){
                    //一口价订单
                    $order_amount = $goods['service_fee']*$val['goods_number'];
                }else{
                    $order_total = $goods['base_service_fee']*$val['goods_number'];
                    $order_amount = $goods['service_fee']*$val['goods_number'];
                }
                $goodsPaymentTypeArr[] = $goods['goods_payment_type'];
                $orderGoodsData[] = [
                    'goods_id' => $goods['id'],
                    'category_type' => $goods['category_type'],
                    'goods_category_ids' => $goods['goods_category_ids'],
                    'goods_category_id' => $goods['goods_category_id'],
                    'goods_name' => $goods['goods_name'],
                    'goods_image' => $goods['goods_image'],
                    'goods_video' => $goods['goods_video'],
                    'goods_number' => $val['goods_number'],
                    'good_unit' => $goods['good_unit'],
                    'goods_size' => $goods['goods_size'],
                    'goods_type' => $goods['goods_type'],
                    'goods_brand' => $goods['goods_brand'],
                    'install_guide' => $goods['install_guide'],
                    'goods_payment_type'=>$goods['goods_payment_type'],
                    'base_service_fee' => $goods['base_service_fee'],
                    'service_total' => $goods['service_total'],
                    'service_fee' => $goods['service_fee'],
                    'service_image' => $goods['service_image'],
                    'warranty_period'=>$goods['warranty_period'],
                    'fee_schedule' => $goods['fee_schedule'],
                    'goods_status' => $goods['goods_status'],
                ];
            }
            if(count(array_unique($goodsPaymentTypeArr))>1){
                throw new Exception('订单中存在多种支付方式');
            }
            //生成服务工单
            $work_data = [
                'work_sn' => generate_sn(ServiceWork::class, 'work_sn'),
                'real_name' => $params['contact_people'],
                'mobile' => $params['contact_number'],
                'address' => $params['address'],
                'title' => $goods['goods_name'] . '*' .$val['goods_number'].$goods['good_unit'],
                'category_type' => $goods['category_type'],
                'goods_category_ids' => $goods['goods_category_ids'],
                'goods_category_id' => $goods['goods_category_id'],
                'base_service_fee' => $goods['base_service_fee'],
                'service_fee' => $goods['service_fee'],
                'work_pay_status'=>WorkEnum::UN_PAY_STATUS,
                'appointment_time' => strtotime($params['appointment_time']),
                'user_id' => $params['user_id'],
                'work_type' => 1,
            ];
            $service_work = ServiceWork::create($work_data);

            //生成服务订单
            $data = [
                'work_id'=> $service_work['id'],
                'sn' => generate_sn(RechargeOrder::class, 'sn'),
                'order_type'=>0,//服务订单
                'order_terminal' => $params['terminal'],
                'payment_type'=>$goods['goods_payment_type']==1?1:0,
                'user_id' => $params['user_id'],
                'pay_status' => PayEnum::UNPAID,
                'coupon_id'=>!empty($params['coupon_id'])?$params['coupon_id']:0,
                'coupon_price'=>!empty($order_coupon_amount)?$order_coupon_amount:0,
                'pay_way' => $params['pay_way'],
                'order_total' => $order_total,
                'order_amount' => $order_amount,
            ];

            $order = RechargeOrder::create($data);
            array_walk($orderGoodsData, function (&$value, $key, $data) {
                $value = array_merge($value, ['sn' => $data['sn']]);
            },$data);
            $orderGoodsModel = new OrderGoods();
            $orderGoodsModel->saveAll($orderGoodsData);
            Db::commit();
            return [
                'order_id' => (int)$order['id'],
            ];
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }
}